/*
 *	COPY OF maistro:/usr/include/sys/file.h
 */

/*
 *	@(#)file.h	18.1	91/08/08	ACE (c)
 */

#ifndef FILE_H
#define FILE_H

/*
 * One file structure is allocated
 * for each open/creat/pipe call.
 * Main use is to hold the read/write
 * pointer associated with each open
 * file.
 */
struct	file
{
	char	f_flag;
	char	f_eflag;	/* file descriptor type, and extra flags     */
	short	f_align;	/* alignment to long */
	short	f_count;	/* reference count */
	short	f_msgcount;	/* references from message queue	*/
	union	{
		struct inode	*F_inode;	/* pointer to inode structure */
		struct socket	*F_socket;	/* pointer to socket	      */
	}f_un;
#define f_inode 	f_un.F_inode
#define f_socket	f_un.F_socket
	off_t	f_offset;	/* read/write character pointer */
};

/* Functions */
#ifdef KERNEL
struct file *getf();
struct file *falloc();
#endif

/* tricky truc to map 0, 1, 2 to FREAD, FWRITE */
#define FOPEN	(-1)
/* flags */
#define	FREAD	00001
#define	FWRITE	00002
#define	FNDELAY	00004
#define	FAPPEND	00010
#define	FSYNC	00020
#define FMASK	00377

#define FCREAT	00400
#define FTRUNC	01000
#define FEXCL	02000
#define FSAFE	04000		/* writes for consistent file system */

#define	FE_TYPE_FIELD	03	/* Mask for type field		*/
#define	FE_TYPE_FILE	00	/* Normal file			*/
#define	FE_TYPE_SOCKET	01	/* file descr. is socket	*/
#define	FE_DEFER	04	/* defer till nect gc() pass	*/
#define	FE_MARK		010	/* mark during gc()		*/

#define	SEL_CLEAN	(-1)	/* Cleanup pointers to current process	*/
#define	SEL_EXCEPT	0	/* Select for exception			*/
#define	SEL_READ	1	/* Select for read			*/
#define	SEL_WRITE	2	/* Select for write			*/

#endif
