/*
 *	COPY OF /usr/local/ace/cross/t800/usr/include/sys/shm.h
 *	CHANGED (unknown type) ulen_t to int
 */

/*
 *	SCCS-info: @(#)shm.h	70.2 92/03/03 (c) ACE
 */
#ifndef	SHM_H
#define	SHM_H


/*
 *	IPC Shared Memory Facility.
 */

/*
**	Implementation Constants.
*/

#define	SHMLBA	ctob(1) /* boundary address multiple */
			/* (SHMLBA must be a power of 2) */

/*
**	Permission Definitions.
*/

#define	SHM_R	0400	/* read permission */
#define	SHM_W	0200	/* write permission */

/*
**	ipc_perm Mode Definitions.
*/

#define	SHM_INIT	01000	/* grow segment on next attach */
#define	SHM_DEST	02000	/* destroy segment when # attached = 0 */

/*
**	Message Operation Flags.
*/

#define	SHM_RDONLY	010000	/* attach read-only (else read-write) */
#define	SHM_RND		020000	/* round attach address to SHMLBA */

/*
**	Structure Definitions.
*/

/*
**	There is a shared mem id data structure for each segment in the system.
*/

struct shmid_ds {
	struct ipc_perm	shm_perm;	/* operation permission struct */
	int 		shm_segsz;	/* size of segment in bytes */
	struct segmstr *shm_sgp;	/* ptr to segment */
	ushort		shm_lpid;	/* pid of last shmop */
	ushort		shm_cpid;	/* pid of creator */
	ushort		shm_nattch;	/* used only for shminfo */
	ushort		shm_cnattch;	/* used only for shminfo */
	time_t		shm_atime;	/* last shmat time */
	time_t		shm_dtime;	/* last shmdt time */
	time_t		shm_ctime;	/* last change time */
};

struct	shminfo {
	int	shmmax,		/* max shared memory segment size */
		shmmin,		/* min shared memory segment size */
		shmmni,		/* # of shared memory identifiers */
		shmseg;		/* max. # of shared memory identifiers
				   per process */
	struct shmid_ds *shmbuf;/* pointer to shm descriptorss	  */
};


/*
 * Shared memory control operations
 */

#define SHM_LOCK	3	/* Lock segment in core */
#define SHM_UNLOCK	4	/* Unlock segment */

#ifdef	KERNEL
extern struct shmid_ds	shmem[];	/* shared memory headers */
extern struct shminfo	shminfo;	/* shared memory info structure */
#endif	/* KERNEL */

#endif	/* SHM_H */
